package  {
	
	import flash.display.Sprite;
	import flash.events.Event;

	public class Field extends Sprite {
		
		public var numMines:int;
		public var cols:int;
		public var rows:int;
		
		public var cells:Array = [ ];
		
		public function Field(rows:int, cols:int, numMines:int) {
			
			this.numMines = numMines;
			this.cols = cols;
			this.rows = rows;
			
			newGame();
		}
		
		public function newGame():void {
			for (var i:int = 0; i < cols; i++) {
				for (var j:int = 0; j < rows; j++) {
					var cell:Cell = new Cell(i, j, this);
					addChild(cell);
					cells.push(cell);
				}
			}
			
			addEventListener(Event.OPEN, onFirstOpened);
		}
		
		public function calculateMines(i:int, j:int):int {
			var list:Array = getAllAround(i, j);
			var calcMines:int = 0;
			
			for (var a:int = 0; a < list.length; a++) {
				if (list[a].isMine) calcMines++;
			}
			
			return calcMines;
		}
		
		public function openAllAround(i:int, j:int):void {
			var list:Array = getAllAround(i, j);
			
			for (var a:int = 0; a < list.length; a++) {
				list[a].open();
			}
		}
		
		private function getAllAround(i:int, j:int):Array {
			var list:Array = [ ];
			
			addExists(list, i - 1, j - 1);
			addExists(list, i - 1, j);
			addExists(list, i - 1, j + 1);
			
			addExists(list, i, j - 1);
			addExists(list, i, j + 1);
			
			addExists(list, i + 1, j - 1);
			addExists(list, i + 1, j);
			addExists(list, i + 1, j + 1);
			
			return list;
		}
		
		private function addExists(list:Array, i:int, j:int):void {
			var index:int = i * cols + j;
			
			if (i < 0) return;
			if (i >= cols) return;
			
			if (j < 0) return;
			if (j >= rows) return;
			
			list.push(cells[index]);
		}
		
		private function onFirstOpened(e:Event):void {
			removeEventListener(Event.OPEN, onFirstOpened);
			var firstCell:Cell = e.target as Cell;
			
			var leftMines:int = numMines;
			
			while (leftMines > 0) {
				var index:int = Math.floor(Math.random() * cells.length);
				var cell:Cell = cells[index];
				
				if (cell == firstCell) continue;
				if (cell.isMine) continue;
				
				cell.isMine = true;
				leftMines--;
			}
			
		}
		
	}

}